searchNodes=[{"type":"module","title":"Barytherium","doc":"Barytherium is an Elixir STOMP client, and a replacement for Mammoth/Elephant, with the aim of improving performance, particularly for high-volume binary message queues (such as National Rail Enquiries' Darwin push port)","ref":"Barytherium.html"},{"type":"module","title":"Barytherium.DefaultCallbackHandler","doc":"This module serves as a more-or-less self-contained example of how to use Barytherium in your own project. ( 1 ) &gt; { :ok , bdcbh_pid } = Barytherium.DefaultCallbackHandler . start_link ( &#39;example.com&#39; , 61613 , &quot;/&quot; , [ { &quot;login&quot; , &quot;grimAuxiliatrix&quot; } , { &quot;passcode&quot; , &quot;hunter2&quot; } , { &quot;heart-beat&quot; , &quot;5000,5000&quot; } ] , [ % Barytherium.Frame { command : :subscribe , headers : [ { &quot;id&quot; , &quot;0&quot; } , { &quot;destination&quot; , &quot;/amq/queue/darwin-v16-gzip&quot; } , { &quot;ack&quot; , &quot;client&quot; } ] } ] ) { :ok , # PID &lt; 0 . 270 . 0 &gt; } ( 2 ) &gt; 20 : 44 : 51.229 [ info ] Connection to example . com : 61613 succeeded , remote end has picked up 20 : 44 : 51.406 [ info ] Received connected frame : % Barytherium.Frame { command : :connected , headers : [ { &quot;server&quot; , &quot;RabbitMQ/3.10.5&quot; } , { &quot;session&quot; , &quot;session-1uw6oN9eUYg8MyRacmDcnw&quot; } , { &quot;heart-beat&quot; , &quot;5000,5000&quot; } , { &quot;version&quot; , &quot;1.2&quot; } ] , body : &quot;&quot; } 20 : 44 : 51.710 [ info ] Unpacked final frame in list : % Barytherium.Frame { command : :message , ...","ref":"Barytherium.DefaultCallbackHandler.html"},{"type":"function","title":"Barytherium.DefaultCallbackHandler.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Barytherium.DefaultCallbackHandler.html#child_spec/1"},{"type":"function","title":"Barytherium.DefaultCallbackHandler.handle_frame/2","doc":"","ref":"Barytherium.DefaultCallbackHandler.html#handle_frame/2"},{"type":"function","title":"Barytherium.DefaultCallbackHandler.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Barytherium.DefaultCallbackHandler.html#init/1"},{"type":"function","title":"Barytherium.DefaultCallbackHandler.start_link/7","doc":"","ref":"Barytherium.DefaultCallbackHandler.html#start_link/7"},{"type":"module","title":"Barytherium.Frame","doc":"Representation of a STOMP frame. In STOMP, each frame has three components: command (1, mandatory) - only specified commands are permitted headers (0 or more, see below) - unspecified headers permitted body (empty for commands other than SEND, MESSAGE and ERROR) Most commands have required and optional headers, and non-specified headers can also be given (though these have no specified semantics, of course). Most headers aren't relevant to frame parsing, with the exception of content-length, which defines the length of a frame's body. It's legal for header keys to be duplicated. In this case, only the first takes effect. Supported client frames: :stomp (STOMP) :connect (CONNECT) :disconnect (DISCONNECT) :ack (ACK) :nack (NACK) :begin (BEGIN) :commit (COMMIT) :abort (ABORT) :send (SEND) :subscribe (SUBSCRIBE) :unsubscribe (UNSUBSCRIBE) Supported server frames: :connected (CONNECTED) :error (ERROR) :message (MESSAGE) :receipt (RECEIPT) Specification section: https://stomp.github.io/stomp-specification-1.2.html#STOMP_Frames","ref":"Barytherium.Frame.html"},{"type":"function","title":"Barytherium.Frame.format/1","doc":"","ref":"Barytherium.Frame.html#format/1"},{"type":"function","title":"Barytherium.Frame.headers_to_map/1","doc":"","ref":"Barytherium.Frame.html#headers_to_map/1"},{"type":"function","title":"Barytherium.Frame.parse/1","doc":"","ref":"Barytherium.Frame.html#parse/1"},{"type":"function","title":"Barytherium.Frame.parse_all/1","doc":"","ref":"Barytherium.Frame.html#parse_all/1"},{"type":"type","title":"Barytherium.Frame.frame_body/0","doc":"","ref":"Barytherium.Frame.html#t:frame_body/0"},{"type":"type","title":"Barytherium.Frame.frame_command/0","doc":"","ref":"Barytherium.Frame.html#t:frame_command/0"},{"type":"type","title":"Barytherium.Frame.frame_headers/0","doc":"","ref":"Barytherium.Frame.html#t:frame_headers/0"},{"type":"type","title":"Barytherium.Frame.parse_state/0","doc":"","ref":"Barytherium.Frame.html#t:parse_state/0"},{"type":"type","title":"Barytherium.Frame.parse_state_return/0","doc":"","ref":"Barytherium.Frame.html#t:parse_state_return/0"},{"type":"type","title":"Barytherium.Frame.t/0","doc":"","ref":"Barytherium.Frame.html#t:t/0"},{"type":"module","title":"Barytherium.Frame.Macros","doc":"Macros for defining parse parse functions for commands, for both LF and CRLF versions.","ref":"Barytherium.Frame.Macros.html"},{"type":"macro","title":"Barytherium.Frame.Macros.format_fn_command/2","doc":"","ref":"Barytherium.Frame.Macros.html#format_fn_command/2"},{"type":"macro","title":"Barytherium.Frame.Macros.parse_fn_command/2","doc":"","ref":"Barytherium.Frame.Macros.html#parse_fn_command/2"},{"type":"module","title":"Barytherium.Frame.ValueEncoding","doc":"ValueEncoding functions for STOMP. This is handled automatically by functions in Barytherium.Frame Value Encoding is the limited set of escape characters used in headers to avoid control characters In short: Colon ( : ) → c Backslash ( `) → ` Carriage Return ( ) → Line feed ( ) → Any other characters aren't valid and should be treated as an error (but aren't here, yet) https://stomp.github.io/stomp-specification-1.2.html#Value_Encoding","ref":"Barytherium.Frame.ValueEncoding.html"},{"type":"function","title":"Barytherium.Frame.ValueEncoding.decode/1","doc":"","ref":"Barytherium.Frame.ValueEncoding.html#decode/1"},{"type":"function","title":"Barytherium.Frame.ValueEncoding.encode/1","doc":"","ref":"Barytherium.Frame.ValueEncoding.html#encode/1"},{"type":"module","title":"Barytherium.Network","doc":"Responsible for coordinating Sender and Receiver. Note that when started, this will immediately (and asynchronously) try to connect to the given host and port. When the connection succeeds or fails, Network will cast a message to the callback handler, either: {:barytherium, :connect, {:ok, pid()}} or: {:barytherium, :connect, {:error, atom()}} For a successful connection, the pid is for the sender, and this is where you should send a connect frame. For a failed connection, the atom is the error returned by the underlying network driver (e.g. :nxdomain , :econnrefused , etc). This module makes use of Barytherium.Network.Receiver and Barytherium.Network.Sender , see those modules' docs for information about the messages they send. This genserver relays {:barytherium, :disconnect, atom()} messages from Sender and Receiver and ensures that duplicates won't be sent. Note that this does introduce a race condition which could potentially obscure the actual cause of the disconnect.","ref":"Barytherium.Network.html"},{"type":"function","title":"Barytherium.Network.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Barytherium.Network.html#child_spec/1"},{"type":"function","title":"Barytherium.Network.connected?/1","doc":"","ref":"Barytherium.Network.html#connected?/1"},{"type":"function","title":"Barytherium.Network.handle_continue/2","doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Barytherium.Network.html#handle_continue/2"},{"type":"function","title":"Barytherium.Network.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Barytherium.Network.html#init/1"},{"type":"function","title":"Barytherium.Network.start_link/5","doc":"","ref":"Barytherium.Network.html#start_link/5"},{"type":"type","title":"Barytherium.Network.network_buffer_option/0","doc":"","ref":"Barytherium.Network.html#t:network_buffer_option/0"},{"type":"opaque","title":"Barytherium.Network.network_opaque_option/0","doc":"","ref":"Barytherium.Network.html#t:network_opaque_option/0"},{"type":"type","title":"Barytherium.Network.network_option/0","doc":"","ref":"Barytherium.Network.html#t:network_option/0"},{"type":"type","title":"Barytherium.Network.network_options/0","doc":"","ref":"Barytherium.Network.html#t:network_options/0"},{"type":"type","title":"Barytherium.Network.network_receiver_option/0","doc":"","ref":"Barytherium.Network.html#t:network_receiver_option/0"},{"type":"type","title":"Barytherium.Network.network_timeout_option/0","doc":"","ref":"Barytherium.Network.html#t:network_timeout_option/0"},{"type":"module","title":"Barytherium.Network.Parser","doc":"The Parser receives binary data from a Barytherium.Network.Receiver process via casts, parses these into STOMP frames, then casts these on to the listener process. If there's an error parsing, this is reported to Barytherium.Network as a disconnect. If you call instead of cast, any parsed frames (or an empty list otherwise) will be returned to the calling process, this is used by Receiver to get the CONNECTED frame, so it can call Network to finish heartbeat negotiation. Frames are passed via casts to listener_pid , and include a list of frames, and the process ID of the corresponding Barytherium.Network.Sender . A frame list will always include at least one frame. spec: {:barytherium, :frames, {list(Barytherium.Frame.t()), pid()}}","ref":"Barytherium.Network.Parser.html"},{"type":"function","title":"Barytherium.Network.Parser.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Barytherium.Network.Parser.html#child_spec/1"},{"type":"function","title":"Barytherium.Network.Parser.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Barytherium.Network.Parser.html#init/1"},{"type":"function","title":"Barytherium.Network.Parser.send_maybe/3","doc":"","ref":"Barytherium.Network.Parser.html#send_maybe/3"},{"type":"function","title":"Barytherium.Network.Parser.start_link/1","doc":"","ref":"Barytherium.Network.Parser.html#start_link/1"},{"type":"module","title":"Barytherium.Network.Receiver","doc":"The Receiver is designed to work with Barytherium.Network to move frames from an already opened socket, reporting status back to an instance of Barytherium.Network , and frames onwards to the parser. This is implemented as a loop with no message receiving capabilities, outside of the reply made to a call to Barytherium.Network to report the CONNECTED frame, for which it receives back a tuple which sets out the heartbeats. The loop ends on most error conditions, including those which can be created elsewhere (e.g. if it gets {:error, :closed} when calling recv).","ref":"Barytherium.Network.Receiver.html"},{"type":"function","title":"Barytherium.Network.Receiver.init/1","doc":"","ref":"Barytherium.Network.Receiver.html#init/1"},{"type":"function","title":"Barytherium.Network.Receiver.loop/1","doc":"Pulls data from socket and parses it for STOMP frames until there's an error condition. Errors are casts to listener_pid proxied via the corresponding Barytherium.Network . If an error is emitted, the socket is closed and the loop ends. spec: {:barytherium, :disconnect, atom()} Currently, you can expect :timeout, :closed, and :parse_error in the final position. Note that :timeout from Receiver expresses either a heartbeat timeout, or a pre-defined timeout of 5000ms while waiting for the CONNECTED frame, there is currently no other mechanism to specify receive timeout. When the first frame (which must be a CONNECTED frame) is parsed, this comes back to the Receiver, which calls the corresponding Barytherium.Network with {:connected_frame, frame} . The reply to this message should be a tuple of two integers which express the agreed heartbeats for sending and receiving, respectively. Note that the parsing itself happens in the Parser process, and parsing results originate from that process.","ref":"Barytherium.Network.Receiver.html#loop/1"},{"type":"function","title":"Barytherium.Network.Receiver.start_link/5","doc":"Start the receiver loop as a linked task, see loop/1 .","ref":"Barytherium.Network.Receiver.html#start_link/5"},{"type":"type","title":"Barytherium.Network.Receiver.receiver_option/0","doc":"","ref":"Barytherium.Network.Receiver.html#t:receiver_option/0"},{"type":"type","title":"Barytherium.Network.Receiver.receiver_options/0","doc":"","ref":"Barytherium.Network.Receiver.html#t:receiver_options/0"},{"type":"opaque","title":"Barytherium.Network.Receiver.state/0","doc":"","ref":"Barytherium.Network.Receiver.html#t:state/0"},{"type":"module","title":"Barytherium.Network.Sender","doc":"Genserver for sending frames, see Barytherium.Network.Sender.write/2","ref":"Barytherium.Network.Sender.html"},{"type":"function","title":"Barytherium.Network.Sender.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Barytherium.Network.Sender.html#child_spec/1"},{"type":"function","title":"Barytherium.Network.Sender.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Barytherium.Network.Sender.html#init/1"},{"type":"function","title":"Barytherium.Network.Sender.start_link/4","doc":"","ref":"Barytherium.Network.Sender.html#start_link/4"},{"type":"function","title":"Barytherium.Network.Sender.write/2","doc":"Formats and writes a list of frames to the underlying socket. Always returns :ok, if there's an error condition it'll be expressed in a cast to the listener process, spec: {:barytherium, :disconnect, atom()} The current final atom can be either :closed or :timeout . Note that when you use this to send a CONNECT frame, it will read the heart-beat header if set, and communicate this to the corresponding Barytherium.Network process to inform heartbeat negotiation.","ref":"Barytherium.Network.Sender.html#write/2"}]